org.apache.commons.math.linear

## Class DefaultFieldMatrixPreservingVisitor<T extends FieldElement<T>>

- java.lang.Object
- - org.apache.commons.math.linear.DefaultFieldMatrixPreservingVisitor<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  FieldMatrixPreservingVisitor<T>

Direct Known Subclasses:
  MatrixUtils.BigFractionMatrixConverter, MatrixUtils.FractionMatrixConverter

    public class DefaultFieldMatrixPreservingVisitor<T extends FieldElement<T>>
    extends java.lang.Object
    implements FieldMatrixPreservingVisitor<T>

Default implementation of the `FieldMatrixPreservingVisitor` interface.

This class is a convenience to create custom visitors without defining all methods. This class provides default implementations that do nothing.

Since:
  2.0
Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 févr. 2011) $

### Field Summary

Fields
`private T` `zero` Zero element of the field.

### Constructor Summary

Constructors
Constructor and Description
`DefaultFieldMatrixPreservingVisitor(T zero)` Build a new instance.

### Method Summary

Methods
`T` `end()` End visiting a matrix.
`void` `start(int rows, int columns, int startRow, int endRow, int startColumn, int endColumn)` Start visiting a matrix.
`void` `visit(int row, int column, T value)` Visit one matrix entry.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### zero

    private final T extends FieldElement<T> zero

Zero element of the field.

### Constructor Detail

#### DefaultFieldMatrixPreservingVisitor

    public DefaultFieldMatrixPreservingVisitor(T zero)

Build a new instance.

Parameters:
  `zero` - additive identity of the field

### Method Detail

#### start

    public void start(int rows,
             int columns,
             int startRow,
             int endRow,
             int startColumn,
             int endColumn)

Start visiting a matrix.

This method is called once before any entry of the matrix is visited.

Specified by:
  `start` in interface `FieldMatrixPreservingVisitor<T extends FieldElement<T>>`
Parameters:
  `rows` - number of rows of the matrix
  `columns` - number of columns of the matrix
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)

#### visit

    public void visit(int row,
             int column,
             T value)
               throws MatrixVisitorException

Visit one matrix entry.

Specified by:
  `visit` in interface `FieldMatrixPreservingVisitor<T extends FieldElement<T>>`
Parameters:
  `row` - row index of the entry
  `column` - column index of the entry
  `value` - current value of the entry
Throws:
  `MatrixVisitorException` - if something wrong occurs

#### end

    public T end()

End visiting a matrix.

This method is called once after all entries of the matrix have been visited.

Specified by:
  `end` in interface `FieldMatrixPreservingVisitor<T extends FieldElement<T>>`
Returns:
  the value that the `walkInXxxOrder` must return